{{
2015 Albuquerque Mini Maker Faire Badge-Bot
v. 1.7
}}

CON

{{
CON
_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000
CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq               ' system freq as a constant
}}

  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

  _CR = 13 ' ascii carriage return

        BOTVERSION =            17 ' 10s . 1s

        m1aPin   =  0
        m1bPin   =  1
        m2aPin   =  2
        m2bPin   =  3

        mdPin    =  4
        mdSFpin  =  5

        ADC_D_PIN   = 6
        ADC_CLK_PIN = 7
        ADC_CS_PIN  = 8

        redPin   = 10
        greenPin = 11
        bluePin  =  9

        snrLpin  = 15
        snrCpin  = 14
        snrRpin  = 13

        EMIC_MISO_PIN = 16
        EMIC_MOSI_PIN = 17

        KEYFOB_PIN0 = 18
        KEYFOB_PIN1 = 19
        KEYFOB_PIN2 = 20
        KEYFOB_PIN3 = 21

        svo0pin  = 22
        svo1pin  = 23
        svo2pin  = 24

        ledLpin  = 26
        ledRpin  = 25

        PWR_5V_PIN = 27

        ' useful cons
        LEDPWMFREQ = 300 ' in hz
        LEDPWMPER = 1_000_000/LEDPWMFREQ

        MOTPWMFREQ = 10_000
        MOTPWMPER = 1_000_000/MOTPWMFREQ
        MOTMAX = 40

        'statflag bit assignments
        ROBOMOV =  0
        ROBODIR =  1
        ROBOTRN =  2
        ROBOTDR =  3

        POWEN   =  8
        SNREN   =  9
        IREN    = 10

        LOWBAT  = 12
        MOTSF   = 15

        SNRLLIM = 16
        SNRRLIM = 17
        SNRCLIM = 18

        IRLLIM  = 20
        IRRLIM  = 21
        IRCLIM  = 22


        ' indices
        LEFT   = 0
        RIGHT  = 1
        CTR    = 2

        USR    = 0
        RMP    = 1
        TARG   = 2
        TRMP   = 3
        VALOUT = 4

        RED    = 2
        GREEN  = 1
        BLUE   = 0

        ' keyfob
        KF_A = 0 ' bit pos
        KF_B = 1
        KF_C = 2
        KF_D = 3

        ' mins/maxes
        SVO0MIN =  995
        SVO0MAX = 1773
        SVO0CTR = (SVO0MAX+SVO0MIN)/2
        SVO0OPEN  = SVO0MIN
        SVO0CLOSE = SVO0MAX

        SVO1MIN =  995
        SVO1MAX = 1723
        SVO1CTR = (SVO1MAX+SVO1MIN)/2
        SVO1OPEN  = SVO1MIN
        SVO1CLOSE = SVO1MAX

        SVO2MIN =  995
        SVO2MAX = 1729
        SVO2CTR = (SVO2MAX+SVO2MIN)/2
        SVO2OPEN  = SVO2MIN
        SVO2CLOSE = SVO2MAX

        SUBSTT      = 8
        BATSTATE    = 7
        SPEAKRANST  = 6
        SPEAKSTATE  = 5
        MODESTATE   = 4
        OBSSTATE    = 3
        MOTIONSTATE = 2
        IRISSTATE   = 1
        RINGSTATE   = 0



VAR

        long          stack[500]
        
        long          stackRtc[500]
        long          stackRamps[500]
        long          stackSense[500]

        long          roboStat  ' turnDir | turning | dir | moving

        long          mainFrameCntr

        long          ledFrameCntr
        long          motoFrameCntr
        long          motoRampCntr
        long          svoFrameCntr

        long          secCntr

        long          halfSec

        long          states[10]
        long          tmrs[10] ' down to Z
        long          cntrs[10] ' count up, max 24 hours

        long          moto[10] ' L/R; usr, rmp, targ, trmp, valout

        long          rgb[15] ' 0-2; usr, rmp, targ, trmp, valout

        long          leds[10] ' L/R; usr, rmp, targ, trmp, valout

        long          ledsSaved[10]

        long          sonarVals[6] ' vals + avgs  
        long          irVals[3]

        long          battery

        long          keyfobCurr
        long          keyfobVal
        long          keyfobLast
        long          keyfobCntrs[4]

        long          svo[15] ' 0-2; usr, rmp, targ, trmp, valout

        long          speakNext ' and old
        long          spokeLast ' and old

        long          randSeed

        byte          cogRTC
        byte          cogRamps
        byte          cogSensors





OBJ

  pwm           : "PWM_32_v4.spin"
  i2c           : "Basic_I2C_Driver_1.spin"
  ser           : "FullDuplexSerial_zoot.spin"
  adc           : "jm_mcp3208_ez.spin"
  sonar         : "Ping_zoot.spin"


  pst           : "Parallax Serial Terminal.spin"

PUB Start | idx

  pwm.Start

  pwm.Duty(m1aPin,0,MOTPWMPER)
  pwm.Duty(m1bPin,0,MOTPWMPER)
  pwm.Duty(m2aPin,0,MOTPWMPER)
  pwm.Duty(m2bPin,0,MOTPWMPER)

  pwm.Servo(svo0pin,SVO0OPEN)
  pwm.Servo(svo1pin,SVO1OPEN)
  pwm.Servo(svo2pin,SVO2OPEN)

  pwm.Duty(bluePin, 100-0,LEDPWMPER)
  pwm.Duty(greenPin,100-0,LEDPWMPER)
  pwm.Duty(redPin,  100-0,LEDPWMPER)

  pwm.Duty(ledLpin, 100,LEDPWMPER)
  pwm.Duty(ledRpin, 100,LEDPWMPER)

  outa[mdPin]~ ' clear
  dira[mdPin]~~ ' set (output)

 ' adc.start(ADC_CS_PIN, ADC_CLK_PIN, ADC_D_PIN)            ' start(cspin, clkpin, diopin)

  ser.start(EMIC_MISO_PIN, EMIC_MOSI_PIN, %0000, 9600)  ' emic;  start(rxpin, txpin, mode, baudrate)

  battery := 1150 ' init at 11.5 volts

  roboStat := (%1<<POWEN)|(%1<<SNREN)|(%1<<IREN)

  set_moto( LEFT, 0, 0 )
  set_moto( RIGHT, 0, 0 )

  set_led( LEFT, 100, 0 )
  set_led( RIGHT, 100, 0 )

  set_rgb( RED, 0, 0 )
  set_rgb( GREEN, 0, 0 )
  set_rgb( BLUE, 0, 0 )

  waitcnt( ( clkfreq * 5 ) + cnt )

  ' emic
  emic_wait_prompt
  ser.str(string("V14",_CR)) ' volume set to DB+14; default 0

  emic_wait_prompt
  ser.str(string("W135",_CR)) ' speed 135 words/minute; default 200

  emic_wait_prompt
  ser.str(string("N7",_CR)) ' voice 7; default 0

  
  
  'pst.Start(115200)
  'pst.Home
  
  
  cogRTC := cognew( cog_RTC(@roboStat,@mainFrameCntr,@ledFrameCntr,@motoFrameCntr,@svoFrameCntr), @stackRtc ) ' ,@ms

  cogSensors := cognew( cog_Sensors(@roboStat,@sonarVals,@irVals,@keyfobVal,@keyfobCurr,@battery), @stackSense )

  cogRamps := cognew( cog_Ramps(@roboStat,@ledFrameCntr,@motoFrameCntr,@svoFrameCntr,@moto,@rgb,@leds,@svo), @stackRamps )

  spokeLast := -1

  repeat idx from 0 to 9
    tmrs[idx]~
  repeat idx from 0 to 9
    cntrs[idx]~
  repeat idx from 0 to 3
    keyfobCntrs[idx]~

  secCntr~
  halfSec~

  emic_wait_prompt
  speakStr( 0 ) ' announce version

  states[MODESTATE]~
  states[MOTIONSTATE]~

  tmrs[SPEAKRANST] := get_rand(constant(30*2),constant(60*2))

  Main

PUB Main | idx, tmp1, tmp2, tmp3, tmp4

  repeat

    ' now the frame

    repeat until mainFrameCntr => constant ( 20 / 5 )

    mainFrameCntr -= constant ( 20 / 5 )

    'pst.home
    'pst.char(pst#CS)
    'pst.dec(states[MODESTATE])
    'pst.char(pst#NL)
    'pst.bin(keyfobCurr,4)
    'pst.char(pst#NL)
    'pst.bin(keyfobLast,4)
    

{{ -------------------------------------------------------------------------------------------- }}

    secCntr++
    if secCntr => constant( ( 1000 / 20 ) / 2 ) ' half second
       secCntr~

       halfSec++
       repeat idx from 0 to 9
         if tmrs[idx] <> 0
             tmrs[idx]--
       repeat idx from 0 to 9
          cntrs[idx] := cntrs[idx] + 1 <# constant( ( 24 * 60 * 60 ) * 2 )
       repeat idx from 0 to 3
          keyfobCntrs[idx] := keyfobCntrs[idx] + 1 <# constant( ( 24 * 60 * 60 ) * 2 )

{{ -------------------------------------------------------------------------------------------- }}     

    ' keyfob inputs
    if roboStat & constant(%1<<POWEN) <> 0
       keyfobVal := ( ina >> KEYFOB_PIN0 ) & %1111 ' make nib from KEYFOB_PIN0-KEYFOB_PIN3

       keyfobLast := keyfobCurr
       keyfobCurr := keyfobVal

       if keyfobCurr <> keyfobLast
          set_led( LEFT, 100, 0 )
          set_led( RIGHT, 100, 0 )
    else
       keyfobLast~
       keyfobCurr~
       keyfobVal~
       
{{ -------------------------------------------------------------------------------------------- }}

    ' mode change?
    if keyfobCurr ^ keyfobLast & constant(%1<<KF_A) <> 0 and keyfobCurr & constant(%1<<KF_A) == 0 ' key A released

          if keyfobCntrs[KF_A] => constant(3) ' 1.5 seconds pressed, state change

             keyfobCntrs[KF_A]~

             states[MODESTATE]++
             if states[MODESTATE] > MOTIONSTATE
                states[MODESTATE] := RINGSTATE

             states[SUBSTT]~ ' clear substt
             cntrs[MODESTATE]~ ' clear the counter for the flash

             ' copy over current led settings
             repeat idx from 0 to 2
                ledsSaved[constant(USR*3)+idx] := leds[constant(USR*3)+idx]
                ledsSaved[constant(RMP*3)+idx] := leds[constant(RMP*3)+idx]

             speakIt( 7 + states[MODESTATE] )

    if keyfobCurr & constant(%1<<KF_A) == 0
    
       keyfobCntrs[KF_A]~


{{ -------------------------------------------------------------------------------------------- }}

    if tmrs[SPEAKRANST] == 0 and tmrs[SPEAKSTATE] == 0

       speakIt( get_rand(10,33) )
       tmrs[SPEAKRANST] := get_rand(constant(60*2),constant(120*2))


{{ -------------------------------------------------------------------------------------------- }}

    if states[MODESTATE] == RINGSTATE

       ' here, you can check for key press on change only
       if keyfobCurr & constant(%1<<KF_B) <> 0
          set_rgb(RED, 100, 6 )
          speakIt( constant(1+RED) )
          tmrs[RINGSTATE] := constant(30*2)
       else
          set_rgb(RED, 0, 1 )

       if keyfobCurr & constant(%1<<KF_D) <> 0
          set_rgb(GREEN, 100, 6 )
          speakIt( constant(1+GREEN) )
          tmrs[RINGSTATE] := constant(30*2)
       else
          set_rgb(GREEN, 0, 1 )

       if keyfobCurr & constant(%1<<KF_C) <> 0
          set_rgb(BLUE, 100, 6 )
          speakIt( constant(1+BLUE) )
          tmrs[RINGSTATE] := constant(30*2)
       else
          set_rgb(BLUE, 0, 1 )

       show_sonar_light

       if keyfobCurr == %0000
          show_sonar_iris
       else
          set_svo( 0, SVO0CLOSE, 10 )
          set_svo( 1, SVO1CLOSE, 10 )
          set_svo( 2, SVO2CLOSE, 10 )



{{ -------------------------------------------------------------------------------------------- }}


    if states[MODESTATE] == IRISSTATE

      if keyfobCurr & constant(%1<<KF_B) <> 0  ' key B pressed

        tmrs[IRISSTATE] := constant( 30 * 2 )

        if states[SUBSTT] == 0
          states[SUBSTT] := 2 ' get_rand( 1, 8 )

        if states[SUBSTT] => 2

          if svo[constant(VALOUT*3+0)] <> SVO0OPEN
             set_svo( 0, SVO0OPEN, 11 )
          else
               if svo[constant(VALOUT*3+1)] <> SVO1OPEN
                  set_svo( 1, SVO1OPEN, 11 )
               else
                  if svo[constant(VALOUT*3+2)] <> SVO2OPEN
                     set_svo( 2, SVO2OPEN, 11 )
                  else
                     states[SUBSTT] := 1
        else

          if svo[constant(VALOUT*3+0)] <> SVO0CLOSE
             set_svo( 0, SVO0CLOSE, 11 )
          else
               if svo[constant(VALOUT*3+1)] <> SVO1CLOSE
                  set_svo( 1, SVO1CLOSE, 11 )
               else
                  if svo[constant(VALOUT*3+2)] <> SVO2CLOSE
                     set_svo( 2, SVO2CLOSE, 11 )
                  else
                     states[SUBSTT] := 2

      elseif keyfobCurr & constant((%1<<KF_C)|(%1<<KF_D)) == constant((%1<<KF_C)|(%1<<KF_D)) ' both C and D
        ' easter egg -- stop mid motion
        set_svo(0,svo[constant(VALOUT*3+0)],0)
        set_svo(1,svo[constant(VALOUT*3+1)],0)
        set_svo(2,svo[constant(VALOUT*3+2)],0)
        tmrs[IRISSTATE] := constant( 55 * 2 )

      elseif ( keyfobCurr ^ keyfobLast ) & constant(%1<<KF_C) <> 0 and keyfobCurr & constant(%1<<KF_C) == 0 ' key C released
        set_svo( 0, SVO0CLOSE, 16 )
        set_svo( 1, SVO1CLOSE, 16 )
        set_svo( 2, SVO2CLOSE, 16 )
        speakIt( 4 )
        tmrs[IRISSTATE] := constant( 55 * 2 )

      elseif ( keyfobCurr ^ keyfobLast ) & constant(%1<<KF_D) <> 0 and keyfobCurr & constant(%1<<KF_D) == 0 ' key D released
        set_svo( 0, SVO0OPEN, 16 )
        set_svo( 1, SVO1OPEN, 16 )
        set_svo( 2, SVO2OPEN, 16 )
        speakIt( 5 )
        tmrs[IRISSTATE] := constant( 55 * 2 )

      else
         show_sonar_iris

      show_sonar_light



{{ -------------------------------------------------------------------------------------------- }}

    if states[MODESTATE] == MOTIONSTATE

      if keyfobCurr & constant(%1<<KF_B) <> 0 ' key B is stop/go and saved motion state... motion actually happens below

            if states[MOTIONSTATE] <> 1
              states[MOTIONSTATE] := 1
              tmrs[MOTIONSTATE] := get_rand( constant(45*2), constant(60*2) )
              states[SUBSTT]~

      elseif ( keyfobCurr ^ keyfobLast ) & constant(%1<<KF_B) <> 0 and keyfobCurr & constant(%1<<KF_B) == 0 ' key B released... STOP

         states[MOTIONSTATE]~
         set_moto( LEFT, -1, 0 )
         set_moto( RIGHT, -1, 0 )

      elseif keyfobCurr & constant(%1<<KF_C) <> 0 ' rotate CCW
          states[MOTIONSTATE]~ ' clear motion
          set_moto( LEFT,  constant(-(MOTMAX*50/100)), 1 )
          set_moto( RIGHT, constant(MOTMAX*50/100),    1 )


      elseif keyfobCurr & constant(%1<<KF_D) <> 0 ' rotate CW
          states[MOTIONSTATE]~ ' clear motion
          set_moto( LEFT,  constant(MOTMAX*50/100),    1 )
          set_moto( RIGHT, constant(-(MOTMAX*50/100)), 1 )

      else
         set_moto( LEFT, 0, 20 )
         set_moto( RIGHT, 0, 20 )

      show_sonar_light

      'if tmrs[IRISSTATE] == 0
      if roboStat & constant(%1<<ROBOMOV) <> 0
            set_svo( 0, SVO0CLOSE, 18 )
            set_svo( 1, SVO1CLOSE, 18 )
            set_svo( 2, SVO2CLOSE, 18 )
      else
            set_svo( 0, SVO0OPEN, 4 )
            set_svo( 1, SVO1OPEN, 4 )
            set_svo( 2, SVO2OPEN, 4 )

{{ -------------------------------------------------------------------------------------------- }}

     ' motion
    if states[MOTIONSTATE] <> 0

         if states[SUBSTT] == 0

            tmp1 := 50
            if sonarVals[constant(3+CTR)] < 120
               tmp1 := 40
               
            if halfSec & %0100 == 0
               set_moto( LEFT,  MOTMAX*(tmp1-2)/100, 1 )
               set_moto( RIGHT, MOTMAX*tmp1/100, 1 )
            else
               set_moto( LEFT,  MOTMAX*tmp1/100, 1 )
               set_moto( RIGHT, MOTMAX*(tmp1-2)/100, 1 )

            if sonarVals[LEFT] < 90 or sonarVals[RIGHT] < 90 or sonarVals[CTR] < 100

               if sonarVals[LEFT] > sonarVals[RIGHT] and ( (sonarVals[LEFT]-sonarVals[RIGHT]) > (sonarVals[LEFT]+sonarVals[RIGHT])/6 )
                  roboStat &= constant(!(%1<<ROBODIR))
               elseif sonarVals[RIGHT] > sonarVals[LEFT] and ( (sonarVals[RIGHT]-sonarVals[LEFT]) > (sonarVals[LEFT]+sonarVals[RIGHT])/6 )
                  roboStat |= constant(%1<<ROBODIR)

               states[SUBSTT] := 1

         else

            if robostat&(%1<<ROBODIR) == 0 ' turning left
               tmp1 := sonarVals[RIGHT]
            else
               tmp1 := sonarVals[LEFT]

            if tmp1 > 90 and sonarVals[CTR] > 100

                if roboStat & constant(%1<<ROBOTRN) <> 0
                  set_moto( LEFT,  constant(MOTMAX*25/100), 20 )
                  set_moto( RIGHT, constant(MOTMAX*25/100), 20 )
                else
                  states[SUBSTT]~

            else
               if roboStat & constant(%1<<ROBODIR) == 0 ' left
                  set_moto( LEFT, constant(-(MOTMAX*25/100)), 2 )
                  set_moto( RIGHT, constant(MOTMAX*45/100), 1 )
                  if halfSec & %1 == 0
                     set_led( RIGHT, 100, 0 )
                  else
                     set_led( RIGHT, 0, 0 )
                  set_led( LEFT, 0, 20 )
               else
                  set_moto( LEFT, constant(MOTMAX*45/100), 1 )
                  set_moto( RIGHT, constant(-(MOTMAX*25/100)), 2 )
                  if halfSec & %1 == 0
                     set_led( LEFT, 100, 0 )
                  else
                     set_led( LEFT, 0, 0 )
                  set_led( RIGHT, 0, 20 )

         'if keyfobCurr == %0000
         show_sonar_light

      '   if tmrs[MOTIONSTATE] == 0
           '  states[MOTIONSTATE]~


{{ -------------------------------------------------------------------------------------------- }}

    if cntrs[MODESTATE] < constant( 1 * 2 )
          set_rgb(RED,100,0)
          set_rgb(GREEN,100,0)
          set_rgb(BLUE,100,0)
    elseif cntrs[MODESTATE] < constant( 2 * 2 )
          set_rgb(RED,get_rand(0,100),0)
          set_rgb(GREEN,get_rand(0,100),0)
          set_rgb(BLUE,get_rand(0,100),0)

    elseif cntrs[MODESTATE] == constant( 2 * 2 )

             repeat idx from 0 to 2
                set_rgb( idx, ledsSaved[constant(USR*3)+idx], ledsSaved[constant(RMP*3)+idx] )



{{ -------------------------------------------------------------------------------------------- }}

    ' battery?
    if battery < 1070 ' 10.7 volts

       if cntrs[BATSTATE] => constant( 60 * 2 ) ' one minute

         speakIt( 6 )

         set_moto( LEFT, 0, 0 )
         set_moto( RIGHT, 0, 0 )

         set_rgb( RED, 0, 20 )
         set_rgb( GREEN, 0, 20 )
         set_rgb( BLUE, 0, 20 )

         set_svo( 0, SVO0OPEN, 50 )
         set_svo( 1, SVO1OPEN, 50 )
         set_svo( 2, SVO2OPEN, 50 )

         if halfSec & %111 == 0
            set_led( LEFT, 50, 3 )
            set_led( RIGHT, 0, 3 )
         else
            set_led( LEFT, 0, 3 )
            set_led( RIGHT, 50, 3 )

         roboStat &= constant( !( (%1<<POWEN)|(%1<<IREN)|(%1<<SNREN) ) )

    else
       cntrs[BATSTATE]~
       roboStat |= constant( (%1<<POWEN)|(%1<<IREN)|(%1<<SNREN) )



{{ -------------------------------------------------------------------------------------------- }}
    ' post user values to targets...

    ' left
    tmp1 := -MOTMAX #> moto[constant((USR*2)+LEFT)] <# MOTMAX
    tmp2 := 0 #> moto[constant((RMP*2)+LEFT)] <# 100

    ' right
    tmp3 := -MOTMAX #> moto[constant((USR*2)+RIGHT)] <# MOTMAX
    tmp4 := 0 #> moto[constant((RMP*2)+RIGHT)] <# 100

    ' left
    if roboStat & constant( %1<<SNREN ) == 0 or roboStat & constant( %1<<IREN ) == 0 
      tmp1~
      tmp2~
    elseif sonarVals[LEFT] < 30 or sonarVals[CTR] < 30
      tmp1 := tmp1 <# 0
      tmp2~

    if roboStat & constant( %1<<ROBOTRN ) <> 0
      if irVals[LEFT] > 1150
        if tmp1 > 0
          tmp1~
          tmp2~
      if irVals[RIGHT] > 1150
        if tmp1 < 0 ' set to rev
          tmp1~
          tmp2~
    moto[constant((TARG*2)+LEFT)] := tmp1
    moto[constant((TRMP*2)+LEFT)] := tmp2

    ' right
    if roboStat & constant( %1<<SNREN ) == 0 or roboStat & constant( %1<<IREN ) == 0
      tmp3~
      tmp4~
    elseif sonarVals[RIGHT] < 30 or sonarVals[CTR] < 30
      tmp3 := tmp3 <# 0
      tmp4~
    if roboStat & constant( %1<<ROBOTRN ) <> 0
      if irVals[RIGHT] > 1150
        if tmp3 > 0
          tmp3~
          tmp4~
      if irVals[LEFT] > 1150
        if tmp3 < 0 ' set to rev
          tmp3~
          tmp4~
    moto[constant((TARG*2)+RIGHT)] := tmp3
    moto[constant((TRMP*2)+RIGHT)] := tmp4
    
{{ -------------------------------------------------------------------------------------------- }}

    leds[constant((TARG*2)+LEFT)]  :=  0 #> leds[constant((USR*2)+LEFT)] <# 100
    leds[constant((TRMP*2)+LEFT)] := 0 #> leds[constant((RMP*2)+LEFT)] <# 100

    leds[constant((TARG*2)+RIGHT)] :=  0 #> leds[constant((USR*2)+RIGHT)] <# 100
    leds[constant((TRMP*2)+RIGHT)] := 0 #> leds[constant((RMP*2)+RIGHT)] <# 100

{{ -------------------------------------------------------------------------------------------- }}

    rgb[constant((TARG*3)+BLUE)] := 0 #> rgb[constant((USR*3)+BLUE)] <# 100
    rgb[constant((TRMP*3)+BLUE)] := 0 #> rgb[constant((RMP*3)+BLUE)] <# 100

    rgb[constant((TARG*3)+GREEN)] := 0 #> rgb[constant((USR*3)+GREEN)] <# 100
    rgb[constant((TRMP*3)+GREEN)] := 0 #> rgb[constant((RMP*3)+GREEN)] <# 100

    rgb[constant((TARG*3)+RED)] := 0 #> rgb[constant((USR*3)+RED)] <# 100
    rgb[constant((TRMP*3)+RED)] := 0 #> rgb[constant((RMP*3)+RED)] <# 100

{{ -------------------------------------------------------------------------------------------- }}

    svo[constant((TARG*3)+0)] := SVO0MIN #> svo[constant((USR*3)+0)] <# SVO0MAX ' svo0
    svo[constant((TRMP*3)+0)] := 0 #> svo[constant((RMP*3)+0)] <# 255

    svo[constant((TARG*3)+1)] := SVO1MIN #> svo[constant((USR*3)+1)] <# SVO1MAX ' svo1
    svo[constant((TRMP*3)+1)] := 0 #> svo[constant((RMP*3)+1)] <# 255

    svo[constant((TARG*3)+2)] := SVO2MIN #> svo[constant((USR*3)+2)] <# SVO2MAX ' svo2
    svo[constant((TRMP*3)+2)] := 0 #> svo[constant((RMP*3)+2)] <# 255


{{
      for some reason, the adc object doesn't play nice when in a separate cog... moving it's init there might help.
      putting the it the mainline helped, and therefore moving on...
}}


{{ -------------------------------------------------------------------------------------------- }}

    ' ir rangers
   {{ if roboStat & constant(%1<<IREN) <> 0

      irVals[LEFT]  := adc.read(4, %0) ' ranger left     
      irVals[RIGHT] := adc.read(5, %0) ' ranger right
      }}
    '  long[irAddr][CTR] := adc.read(6, %0) ' ranger ctr (not hooked up)

{{ -------------------------------------------------------------------------------------------- }}

    ' if robot not moving, get battery voltage and average w/previous reading
  {{  if tmrs[BATSTATE] == 0 and roboStat & constant(%1<<ROBOMOV) == 0
      tmrs[BATSTATE] := constant( 4 * 2 )
      battery := ( battery + battery + ( ( adc.read(7, %0) * 24750 / $10000 ) + 34 ) ) / 3 ' battery -- scale + add back in voltage drop from main diode, in .01 volts
      }}


      {{
      r1 = 68k
      r2 = 20k
      3.205/14.1 =0.227304964539007
      141/3.205 =0.227304964539007 = *  43.993759750390016 in tenth volts
      3.205/3.34 * 4096 = 3390 = 1410/3390 * 65535 = 23512.557251908399
      }}

    {{
    pst.Home
    pst.Char( pst#CS )
    pst.Dec( battery )
    pst.Char( pst#NL )
    pst.Dec( irVals[LEFT] )     
    pst.Char( pst#NL )
    pst.Dec( irVals[RIGHT] )
     }}


      
PUB set_moto( idx, spd, irmp )
    idx &= %1
    moto[constant(USR*2)+idx]  := -MOTMAX #> spd <# MOTMAX
    moto[constant(RMP*2)+idx]  := 0 #> irmp <# 100

PUB set_svo( idx, pos, irmp )

    idx := 0 #> idx <# 2

    case idx
       0:
         svo[constant(USR*3)+idx] := SVO0MIN #> pos <# SVO0MAX
       1:
         svo[constant(USR*3)+idx] := SVO1MIN #> pos <# SVO1MAX
       2:
         svo[constant(USR*3)+idx] := SVO2MIN #> pos <# SVO2MAX

    svo[constant(RMP*3)+idx]  := 0 #> irmp <# 255

PUB set_led( idx, val, irmp )
    idx &= %1
    leds[constant(USR*2)+idx]  := 0 #> val <# 100
    leds[constant(RMP*2)+idx]  := 0 #> irmp <# 100

PUB set_rgb( idx, val, irmp )
    idx := 0 #> idx <# 2
    rgb[constant(USR*3)+idx]  := 0 #> val <# 100
    rgb[constant(RMP*3)+idx]  := 0 #> irmp <# 100

PUB emic_wait_prompt | tmp1
  repeat
    tmp1 := ser.rxcheck
  until tmp1 == ":" or tmp1 == "?"

PUB speakIt( idx ) | tmp1
  if idx => 34
     idx := idx//34
  if idx <> spokeLast
    if tmrs[SPEAKSTATE] == 0
      tmp1 := ser.rxcheck
      if tmp1 == ":" or tmp1 == "?"
        speakStr( idx )
        spokeLast:= idx
        tmrs[SPEAKSTATE] := constant( 4 * 2 ) ' min 4 seconds till next...


PUB show_sonar_light

   if tmrs[RINGSTATE] == 0 ' and keyfobCurr == %0000
                                              
        if sonarVals[LEFT] < 45 and sonarVals[RIGHT] > 45 and sonarVals[CTR] > 45
          speakIt( 1+BLUE )
        elseif sonarVals[CTR] < 45 and sonarVals[LEFT] > 45 and sonarVals[RIGHT] > 45
          speakIt( 1+GREEN )
        elseif sonarVals[RIGHT] < 45 and sonarVals[LEFT] > 45 and sonarVals[CTR] > 45
          speakIt( 1+RED )

        set_rgb( BLUE, 100 - ( 25 #> sonarVals[constant(3+LEFT)] <# 125 - 25 ), 7 )
        set_rgb( GREEN, 100 - ( 25 #> sonarVals[constant(3+CTR)] <# 125 - 25 ), 7 )
        set_rgb( RED, 100 - ( 25 #> sonarVals[constant(3+RIGHT)] <# 125 - 25 ), 7 )


PUB show_sonar_iris

   if tmrs[IRISSTATE] == 0 ' and keyfobCurr == %0000
        set_svo( 0, ( ( ((10#>sonarVals[constant(3+LEFT)]<#40)-10) * (SVO0MAX-SVO0MIN) ) / 30 ) + SVO0MIN, 25 )
        set_svo( 1, ( ( ((10#>sonarVals[constant(3+RIGHT)]<#40)-10) * (SVO1MAX-SVO1MIN) ) / 30 ) + SVO1MIN, 25 )
        set_svo( 2, ( ( ((10#>sonarVals[constant(3+CTR)]<#40)-10) * (SVO2MAX-SVO2MIN) ) / 30 ) + SVO2MIN, 25 )

PUB speakStr( idx ) | addr, addroff, char
      if idx => 34
         idx := idx//34
      addr := @@str_addr[idx]
      addroff := 0
      ser.tx("S")
      if get_rand( 0, 1 ) <> 0
        ser.str(string(":-)0"))
      repeat
        char := byte[addr][addroff++]
        if char <> 0
          ser.tx( char )
      while char <> 0
      ser.tx(_CR)

PUB get_rand( myMin, myMax )
  myMax := myMin #> myMax
  randSeed := ?randSeed + irVals[LEFT] + irVals[RIGHT] + battery + halfSec
  result := ( randSeed // ((myMax+1)-myMin) ) + myMin

PUB cog_RTC( roboStatAddr, mainFrameAddr, ledFrameAddr, motoFrameAddr, svoFrameAddr ) | cnt_next ', secs_cntr, msAddr

  ' init for staggered ramps frames
  long[mainFrameAddr][0] :=  0
  long[ledFrameAddr][0]  :=  1
  long[svoFrameAddr][0]  :=  2
  long[motoFrameAddr][0] :=  3

  cnt_next := ( clkfreq/200 ) + cnt ' 5 ms per tick...

  repeat

    waitcnt ( cnt_next )
    cnt_next := cnt ' capture for overhead

    long[mainFrameAddr][0]++
    long[ledFrameAddr][0]++
    long[motoFrameAddr][0]++
    long[svoFrameAddr][0]++
    'long[msAddr][0] += 5

    'cnt_next := ( clkfreq/1000 ) + cnt - ( cnt-cnt_next <# (clkfreq/2000) )
    cnt_next := ( clkfreq/200 ) + cnt - 8_000
     
PUB cog_ramps( roboStatAddr, ledFrameAddr, motoFrameAddr, svoFrameAddr, motoAddr, rgbAddr, ledsAddr, svoAddr ) | motIdx, ledIdx, svoIdx, tmp1, tmp2, tmp3, p1

  repeat

{{ -------------------------------------------------------------------------------------------- }}

   ' doing motors?
    if long[motoFrameAddr][0] => constant ( 25 / 5 ) ' 25 ms frame * 2 = 50ms per "full pair" tick

      long[motoFrameAddr][0] -= constant ( 25 / 5 )

      motIdx &= %1

      tmp1 := long[motoAddr][constant(TARG*2)+motIdx] ' target speed
      tmp2 := long[motoAddr][constant(VALOUT*2)+motIdx] ' out

      if tmp2 <> tmp1

        tmp3 := long[motoAddr][constant(TRMP*2)+motIdx] ' ramp

        if tmp3 == 0
          tmp2 := tmp1

        elseif tmp2 < tmp1 and motoRampCntr == 0
           tmp2 += tmp3
           if tmp2 > tmp1
              tmp2 := tmp1

        elseif motoRampCntr == 0
           tmp2 -= tmp3
           if tmp2 < tmp1
              tmp2 := tmp1

        tmp2 := -MOTMAX #> tmp2 <# MOTMAX

        long[motoAddr][constant(VALOUT*2)+motIdx] := tmp2 ' this channel's out val

        {{
        if motIdx == LEFT and tmp2 <> 0' cut speed on left, it's too fast for right
            if tmp2 > 0
               tmp2 := tmp2 * 990 / 1000
            else                                  
               tmp2 := -( (||tmp2) * 990 / 1000 ) 
        }}
         
        if tmp2 == 0
            tmp1~
            tmp3~
        elseif tmp2 > 0 ' forward? a pin 100%, b is inv PWM
            tmp1 := 100 ' pin a
            tmp3 := 100-tmp2 ' pin b
        else
            tmp1 := 100-(||tmp2) ' pin a
            tmp3 := 100 ' pin b

        if motIdx == LEFT
           pwm.Duty(m1aPin,tmp1,MOTPWMPER)
           pwm.Duty(m1bPin,tmp3,MOTPWMPER)                 
        else
           pwm.Duty(m2aPin,tmp1,MOTPWMPER)
           pwm.Duty(m2bPin,tmp3,MOTPWMPER)


      if motIdx == RIGHT
    ' on finishing right, do statii
    ' always update motor statii
        tmp1 :=  long[motoAddr][constant(VALOUT*2+LEFT)]
        tmp2 :=  long[motoAddr][constant(VALOUT*2+RIGHT)]
           
        if tmp1 <> 0 or tmp2 <> 0
          long[roboStatAddr][0] |= constant(%1<<ROBOMOV)
        else
          long[roboStatAddr][0] &= constant( !(%1<<ROBOMOV) )
      
        if tmp1 == tmp2
           long[roboStatAddr][0] &= constant( !(%1<<ROBOTRN) )
        else
           long[roboStatAddr][0] |= constant(%1<<ROBOTRN)
           if tmp1 < tmp2
              long[roboStatAddr][0] &= constant( !(%1<<ROBOTDR) ) ' 0 = turning left
           else
              long[roboStatAddr][0] |= constant(%1<<ROBOTDR)


        motoRampCntr := ( motoRampCntr++ ) & %1

        {{
        pst.home
        pst.Char(pst#CS)
        pst.bin( roboStat, 32 )
        pst.char(pst#NL)
        pst.dec(    moto[constant((VALOUT*2)+LEFT)] )
        pst.char(pst#NL)
        pst.dec(    moto[constant((VALOUT*2)+RIGHT)] )
        }}
        
      motIdx++

{{ -------------------------------------------------------------------------------------------- }}

  ' doing all leds?
    if long[ledFrameAddr][0] => constant ( 10 / 5 ) ' 10ms frame * 5 = 50 ms per "tick"

      long[ledFrameAddr][0] -= constant ( 10 / 5 )

      if ledIdx => 5
        ledIdx~

      ' rgb first
      if ledIdx =< 2

        'tmp1 := ( long[rgbAddr][0] >> ( ledIdx << 3 ) ) & $FF ' this channel's rgb byte value
        tmp1 := long[rgbAddr][constant(TARG*3)+ledIdx]  ' this channel's rgb byte value
        tmp2 := long[rgbAddr][constant(VALOUT*3)+ledIdx] ' this channel's out val

        if tmp2 <> tmp1

         tmp3 := long[rgbAddr][constant(TRMP*3)+ledIdx] ' ramp

         if tmp3 == 0
           tmp2 := tmp1

         elseif tmp2 < tmp1
           tmp2 += tmp3
           if tmp2 > tmp1
              tmp2 := tmp1

         else
           tmp2 -= tmp3
           if tmp2 < tmp1
              tmp2 := tmp1

         tmp2 := 0 #> tmp2 <# 100

         long[rgbAddr][constant(VALOUT*3)+ledIdx] := tmp2 ' this channel's out val

         case ledIdx

           BLUE:
             p1 := bluePin
           GREEN:
             p1 := greenPin
           RED:
             p1 := redPin

         pwm.Duty(p1,100-tmp2,LEDPWMPER) ' active low inverted driver

      ' front leds
      else

        tmp1 := long[ledsAddr][constant(TARG*2)+ledIdx-3] ' target value
        tmp2 := long[ledsAddr][constant(VALOUT*2)+ledIdx-3] ' this targets out val

        if tmp2 <> tmp1

          tmp3 := long[ledsAddr][constant(TRMP*2)+ledIdx-3] ' ramp

          if tmp3 == 0
            tmp2 := tmp1

          elseif tmp2 < tmp1
           tmp2 += tmp3
           if tmp2 > tmp1
              tmp2 := tmp1

          else
           tmp2 -= tmp3
           if tmp2 < tmp1
              tmp2 := tmp1

          tmp2 := 0 #> tmp2 <# 100

          long[ledsAddr][constant(VALOUT*2)+ledIdx-3] := tmp2 ' this channel's out val

          if ledIdx == 3
             pwm.Duty(ledLpin,tmp2,LEDPWMPER)
          else
             pwm.Duty(ledRpin,tmp2,LEDPWMPER)

     ledIdx++

{{ -------------------------------------------------------------------------------------------- }}

   ' doing svos
    if long[svoFrameAddr][0] => constant( 10 / 5 ) ' 10ms frame * 2 = ~30ms per "tick"

      long[svoFrameAddr][0] -= constant( 10 / 5 )

      if svoIdx => 3
        svoIdx~

      tmp1 := long[svoAddr][constant(TARG*3)+svoIdx]  ' this channel's rgb byte value
      tmp2 := long[svoAddr][constant(VALOUT*3)+svoIdx] ' this channel's out val

      if tmp2 <> tmp1

         tmp3 := long[svoAddr][constant(TRMP*3)+svoIdx] ' ramp

         if tmp3 == 0
           tmp2 := tmp1

         elseif ( tmp2 < tmp1 )
           tmp2 += tmp3
           if tmp2 > tmp1
              tmp2 := tmp1

         else
           tmp2 -= tmp3
           if tmp2 < tmp1
              tmp2 := tmp1

         case svoIdx
           0:
             tmp2 := SVO0MIN #> tmp2 <# SVO0MAX ' this channel's out val
           1:
             tmp2 := SVO1MIN #> tmp2 <# SVO1MAX ' this channel's out val
           2:
             tmp2 := SVO2MIN #> tmp2 <# SVO2MAX ' this channel's out val

         long[svoAddr][constant(VALOUT*3)+svoIdx] := tmp2
         pwm.Servo(svo0pin+svoIdx,tmp2)

     svoIdx++


PUB cog_Sensors( roboStatAddr, sonarAddr, irAddr, keyfobAddr, keyfobCurrAddr, batteryAddr ) | idx, tmp1

  adc.start(ADC_CS_PIN, ADC_CLK_PIN, ADC_D_PIN)            ' start(cspin, clkpin, diopin)

  repeat

    tmp1 := long[roboStatAddr][0]

    ' sonar
    if tmp1 & constant( %1<<SNREN ) <> 0

      long[sonarAddr][LEFT] := sonar.Centimeters(snrLpin) <# 300
      long[sonarAddr][constant(3+LEFT)] := ( (long[sonarAddr][constant(3+LEFT)]<<1) + long[sonarAddr][LEFT] ) / 3
      waitcnt ( ( clkfreq/67 ) + cnt ) ' 15 ms

      long[sonarAddr][RIGHT] := sonar.Centimeters(snrRpin) <# 300  
      long[sonarAddr][constant(3+RIGHT)] := ( (long[sonarAddr][constant(3+RIGHT)]<<1) + long[sonarAddr][RIGHT] ) / 3
      waitcnt ( ( clkfreq/67 ) + cnt ) ' 15 ms

      long[sonarAddr][CTR] := sonar.Centimeters(snrCpin) <# 300  
      long[sonarAddr][constant(3+CTR)] := ( (long[sonarAddr][constant(3+CTR)]<<1) + long[sonarAddr][CTR] ) / 3
      waitcnt ( ( clkfreq/67 ) + cnt ) ' 15 ms
                                                                                                         

    ' motor driver status flag
    if ina[mdSFpin] == 0
      long[roboStatAddr][0] |= constant( %1 << MOTSF ) ' latching flag; mainline clears


        ' ir rangers
    if roboStat & constant(%1<<IREN) <> 0

      long[irAddr][LEFT]  := adc.read(4, %0) ' ranger left
      long[irAddr][RIGHT] := adc.read(5, %0) ' ranger right
    '  long[irAddr][CTR] := adc.read(6, %0) ' ranger ctr (not hooked up)

{{ -------------------------------------------------------------------------------------------- }}

    ' if robot not moving, get battery voltage and average w/previous reading
    if tmp1 & constant(%1<<ROBOMOV) == 0
      long[batteryAddr][0] := ( (long[batteryAddr][0]<<1 ) + ( ( adc.read(7, %0) * 24750 / $10000 ) + 34 ) ) / 3 ' battery -- scale + add back in voltage drop from main diode, in .01 volts




DAT
 ' Byte-sized/aligned data
  str_00      byte      "I am the 2015 Maker Fair Badge Bot, version ",BOTVERSION/10+"0",".",BOTVERSION//10+"0",".", 0
  str_01      byte      "Blue, blue!", 0
  str_02      byte      "Green, green!", 0
  str_03      byte      "Red, red!", 0
  str_04      byte      "My eye ris closes.", 0
  str_05      byte      "My eye ris opens.", 0
  str_06      byte      "My battery is low. Low voltage! I am shutting down now!", 0
  str_07      byte      "I am in light mode. Play with my lights!", 0
  str_08      byte      "I am in eye ris mode. Play with my eye ris!", 0
  str_09      byte      "I am in motion mode. Drive me around!", 0


  str_10      byte      "Welcome to the 2015 Al boo ker kee Mini Maker Fair!", 0
  str_11      byte      "Am I a he or a she? You decide.", 0
  str_12      byte      "Learn. Create. Build. Make.", 0
  str_13      byte      "I fought the laws of robotics, and the laws won!", 0
  str_14      byte      "Parallax sponsored me.", 0
  str_15      byte      "I was built at Q lab.", 0
  str_16      byte      "Build and launch rockets outside!", 0
  str_17      byte      "Oh, where is my fearless leader?", 0
  str_18      byte      "What did you make today?", 0
  str_19      byte      "Learn to sew in the big top tent.", 0
  str_20      byte      "Visit the maker store outside in the big top tent.", 0
  str_21      byte      "Help decorate an art car. It is outside.", 0
  str_22      byte      "Do you want to learn how to sodder? Visit the big top tent.", 0
  str_23      byte      "hash tag maker fair", 0
  str_24      byte      "hash tag maker fair a b q.", 0
  str_25      byte      "hash tag maker fair a b q 2015."
  str_26      byte      "There are makers upstairs and downstairs.", 0
  str_27      byte      "My maker loves queen Ellen.", 0
  str_28      byte      "Inside! Downstairs! Star ship simulator!", 0
  str_29      byte      "See drones flying outside on the north west field!", 0
  str_30      byte      "Hi there!", 0
  str_31      byte      "Hello!", 0
  str_32      byte      "Come interact with me!", 0
  str_33      byte      "Hey, how ya doing?", 0

  str_addr    word      @str_00, @str_01, @str_02, @str_03, @str_04, @str_05, @str_06, @str_07, @str_08, @str_09, @str_10, @str_11, @str_12, @str_13, @str_14, @str_15, @str_16, @str_17, @str_18, @str_19, @str_20, @str_21, @str_22, @str_23, @str_24, @str_25, @str_26, @str_27, @str_28, @str_29, @str_30, @str_31, @str_32, @str_33
